<!doctype html>
<html>
    <head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>OOP</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>

    <body>
        <div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>
        <div class="reveal">
            <div class="slides">
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h1>Object Oriented Programming</h1>
                    </section>
                    <section>
                        <h2>OOP Overview</h2>
                        <ul>
                            <li>
                                <b>Tenets of OOP</b>
                                <ul>
                                    <li>Encapsulation</li>
                                    <li>Abstraction</li>
                                    <li>Polymorphism</li>
                                    <li>Inheritance</li>
                                </ul>
                            </li>
                            <li>
                                <b>Structure of a Class</b>
                            </li>
                            <li>
                                <b>Instance Creation</b>
                                <ul>
                                    <li>self keyword</li>
                                    <li>__init__()</li>
                                </ul>
                            </li>
                        </ul>
                    </section>
                    <section>
                        <h2>Overview (Cont.)</h2>
                        <ul>
                            <li>
                                <b>Using Attributes</b>
                                <ul>
                                    <li>Access Modifiers</li>
                                    <li>Getters</li>
                                    <li>Setters</li>
                                </ul>
                            </li>
                            <li>
                                <b>Inheritance</b>
                                <ul>
                                    <li>Parent/Child Relationships</li>
                                    <li>super()</li>
                                </ul>
                            </li>
                        </ul>
                    </section>
                    <section>
                        <h2>Overview (Cont.)</h2>
                        <ul>
                            <li>
                                <b>Polymorphism</b>
                                <ul>
                                    <li>Method Overloading</li>
                                    <li>Method Overriding</li>
                                </ul>
                            </li>
                            <li>
                                <b>Composition</b>
                            </li>
                            <li>
                                <b>Modules</b>
                                <ul>
                                    <li>Module Structure and use</li>
                                    <li>Module Import</li>
                                </ul>
                            </li>
                        </ul>
                    </section>
                    <section>
                        <h2>Overview (Cont.)</h2>
                        <ul>
                            <li>
                                <b>Packages</b>
                                <ul>
                                    <li>Package Structure</li>
                                    <li>Useful Commands</li>
                                </ul>
                            </li>
                            <li>
                                <b>Exception Handling</b>
                            </li>
                            <li>
                                <b>Design Principles of OOP</b>
                            </li>
                        </ul>
                    </section>
                    <section>
                        <h2>Objectives</h2>
                        <a href="../objectives.html" target="_blank">Object Oriented Programming Objectives</a>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h2>Tenets of Object Oriented Programming</h2>
                        <ul>
                            <li>Encapsulation</li>
                            <ul>
                                <li>Bundling data together with methods that can operate on the data.</li>
                            </ul>
                        </ul>
                        <ul>
                            <li>Abstraction</li>
                            <ul>
                                <li>Process of removing specific details about an object and making the information more generalized.</li>
                            </ul>
                        </ul>
                    </section>
                    <section>
                        <h2>Tenets of Object Oriented Programming (Cont.)</h2>
                        <ul>
                            <li>Polymorphism</li>
                            <ul>
                                <li>Using the same function or symbol to represent multiple actions.</li>
                            </ul>
                        </ul>
                        <ul>
                            <li>Inheritance</li>
                            <ul>
                                <li>Developing a generic parent class that can be built and expanded upon by a child class.</li>
                            </ul>
                        </ul>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h2>Structure of a Class</h2>
                        <pre>
<code data-trim data-noescape>
class Person(object):
""" A sample of what a class looks like."""
    first_name = "James"
    last_name = "Bond"

    def print_name(cls):
        print(f"My name is {last_name}, {first_name} {last_name}")
</code>
                        </pre>
                    </section>
                    <section>
                        <ul>
                            <li>In our example, we start with the keyword <code>class</code>.</li>
                            <li>We give our class a name that complies with PEP8 standards.</li>
                            <li>We extend from <code>object</code> (we'll go into more details when we get to Inheritance).</li>
                            <li>A docstring is provided, giving some description of our class.</li>
                            <li>We then have some class variables, shared among all instances of Person.</li>
                            <li>Lastly, we have a class method, again available to all instances of Person.</li>
                        </ul>
                    </section>
                    <section>
                        <p>To use our class, we have to instantiate an object of our class.</p>
                        <pre>
<code data-trim data-noescape>
james_bond = Person()
james_bond.print_name()
Person.first_name = "Daniel"
Person.last_name = "Craig"
james_bond.print_name()
</code>
                        </pre>
                        <br>
                        <p>To access elements of a class, we use dot notation.</p>
                    </section>
                    <section>
                        <h2>Changing class variable values</h2>
                        <pre>
<code data-trim data-noescapee>
>>> james_bond = Person()
>>> james_bond.first_name
James
>>> Person.first_name = "Daniel"
>>> james_bond.first_name
Daniel
>>> james_bond.first_name = "James"
>>> james_bond.first_name
James
>>> Person.first_name = "Daniel"
>>> james_bond.first_name
James
</code>
                        </pre>
                        <p style="font-size:30px">Take care when changing class variables, as you can possibly disconnect an object from its class's variables.</p>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h2>Creating an Instance</h2>
                        <ul>
                            <li>Normal use of classes is to set up an individual instance or object.</li>
                            <li>To do so, we'll need to use the <code>self</code> keyword.</li>
                        </ul>
                        <pre>
<code data-trim data-noescape>
class Person(object):
    first_name = "James"
    last_name = "Bond"

    def change_name(self, fname):
        self.first_name = fname
</code>
                        </pre>
                    </section>
                    <section>
                        <h2>Instance Attribute Usage</h2>
                        <pre>
<code data-trim data-noescape>
>>> daniel = Person()
>>> daniel.first_name
James
>>> daniel.change_name("Daniel")
>>> daniel.first_name
Daniel
</code>
                        </pre>
                    </section>
                    <section>
                        <h2><code>__init__()</code></h2>
                        <pre>
<code data-trim data-noescape>
class Person(object):
    def __init__(self, fname, lname):
        self.first_name = fname
        self.last_name = lname

daniel = Person("Daniel", "Craig")
print(f"My name is {daniel.last_name}, {daniel.first_name} {daniel.last_name}")
</code>
                        </pre>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h2>Access Modifiers</h2>
                        <ul>
                            <li>
                                <b>Private</b>
                                <ul>
                                    <li>These attributes <i>should</i> only be accessed by the class itself.</li>
                                    <li>Private attributes have two underscores, __, in front of the name.</li>
                                </ul>
                            </li>
                            <li>
                                <b>Protected</b>
                                <ul>
                                    <li>These attributes <i>should</i> only be accessed by the class itself and any of its child classes.</li>
                                    <li>Protected attributes have one underscore, _, in front of the name.</li>
                                </ul>
                            </li>
                        </ul>
                    </section>
                    <section>
                        <ul>
                            <li>
                                <b>Public</b>
                                <ul>
                                    <li>These attributes can be accessed by any entity.</li>
                                </ul>
                            </li>
                            <li>Within Python, the reality is that all attributes and methods are public.</li>
                            <li>Using either a single or double underscore is more of a <i>guideline</i> to other developers.</li>
                            <li>Care should be taken when thinking of using designated private or protected attributes.</li>
                            <li>A big use of access modifiers is related to Getter and Setters.</li>
                        </ul>                        
                    </section>
                    <section>
                        <h2>Getters / Setters</h2>
                        <ul style="font-size:30px">
                            <li>To control access further to a class's attributes, we can make use of getters and setters.</li>
                            <li>Getters will return the value of an attribute when requested.</li>
                            <li>Setters will assign the provided argument as the value of the attribute.</li>
                            <li>Below is the classic way (for example, in Java) that a getter and setter would be designed.</li>
                        </ul>
                        <pre>
<code data-trim data-noescape>
def get_value(self):
    return self.value

def set_value(self, value):
    self.value = value
</code>
                        </pre>
                    </section>
                    <section>
                        <h2>Using the <code>Property</code> class</h2>
                        <pre>
<code data-trim data-noescape>
class Person(object):
    def __init__(self, name):
        self.name = name

    # getter
    def get_name(self):
        return self.name

    # setter
    def set_name(self, name):
        self.name = name

    name = property(get_name, set_name)
</code>
                        </pre>
                    </section>
                    <section>
                        <h2>Using decorators</h2>
                        <pre>
<code data-trim data-noescape>
class Person(object):
    def __init__(self, name):
        self.name = name

    @property
    def name(self):
        return self.name

    @name.setter
    def name(self, name):
        self.name = name
</code>
                        </pre>
                    </section>
                    <section>
                        <h2>Classes Lab</h2> 
					    <a href="lab5a.html">Lab 5A</a>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h2>Inheritance</h2>
                        <img src="../../assets/animal_tree.jpg" alt="Animal Taxonomy Tree" width="500">
                    </section>
                    <section>
                        <h2>Parent (Super) Class</h2>
                        <pre>
<code data-trim data-noescape>
class Teacher(object):
    def __init__(self, name, college):
        self.name = name
        self.college = college

    def __str__(self):
        return f"{self.name} teaches at {self.college}"

    def salary(self):
        print(f"{self.name} is paid $63,645.")
</code>
                        </pre>
                    </section>
                    <section>
                        <h2>Child (Sub) Class</h2>
                        <pre>
<code data-trim data-noescape>
class PhysicsTeacher(Teacher):
    def __init__(self, name, college, specialty):
        Teacher.__init__(self, name, college)
        self.subject = "Physics"
        self.specialty = specialty

    def __str__(self):
        return super().__str__() + f", teaching the subject {self.subject} with a focus on {self.specialty}"

    def salary(self):
        salary_value = ""
        while not salary_value:
            salary_value = input(f"What is the salary for {self.name}?")
            try:
                self.salary_value = int(salary_value)
            except ValueError:
                print("That is not a valid value for the salary.  Please try again.")
                salary_value = ""
</code>
                        </pre>
                    </section>
                    <section>
                        <h2>Inheritance Lab</h2> 
					    <a href="lab5b.html">Lab 5B</a>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h2>Polymorphism</h2>
                        <ul style="font-size:30px">
                            <li>Method Overloading</li>
                            <ul>
                                <li>Multiple different functions share the same name</li>
                                <li>But have different input/return value types</li>
                                <li>Can be forced into Python, but goes against the language's strengths</li>
                            </ul>
                            <li>Method Overriding</li>
                            <ul>
                                <li>A child class overrides the method it inherits from a parent class</li>
                                <li>The aspect of Polymorphism that Python mainly uses</li>
                            </ul>
                        </ul>
                    </section>
                    <section>
                        <h2>Parent Class</h2>
                        <pre>
<code data-trim data-noescape>
class Teacher(object):
    def __init__(self, name, college):
        self.name = name
        self.college = college

    def __str__(self):
        return f"{self.name} teaches at {self.college}"

    def salary(self):
        print(f"{self.name} is paid $63,645.")
    
    def college_info(self):
        print((f"{self.name} works at {self.college}"))
</code>
                        </pre>
                    </section>
                    <section>
                        <h2>Child Class</h2>
                        <pre>
<code data-trim data-noescape>
class PhysicsTeacher(Teacher):
    def __init__(self, name, college, specialty):
        Teacher.__init__(self, name, college)
        self.subject = "Physics"
        self.specialty = specialty

    def __str__(self):
        return super().__str__() + f", teaching the subject {self.subject} with a focus on {self.specialty}"

    def salary(self):
        salary_value = ""
        while not salary_value:
            salary_value = input(f"What is the salary for {self.name}?")
            try:
                self.salary_value = int(salary_value)
            except ValueError:
                print("That is not a valid value for the salary.  Please try again.")
                salary_value = ""
</code>
                        </pre>
                    </section>
                    <section>
                        <pre>
<code data-trim data-noescape>
jerry = PhysicsTeacher("Jerry", "State", "Asteroids")
print(jerry)         # Example 1
jerry.salary()       # Example 2
jerry.college_info() # Example 3
</code>
                        </pre>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h2>Composition</h2>
                    </section>
                    <section>
                        <h2>Component Classes</h2>
                        <pre>
<code data-trim data-noescape>
class Processor():
    def __init__(self, name, speed, cores):
        self.name = name
        self.speed = speed
        self.cores = cores
    ...

class Motherboard():
    def __init__(self, name, ports):
        self.name = name
        self.ports = ports
    ...

class GraphicsCard():
    def __init__(self, name, memory, features):
        self.name = name
        self.memory = memory
        self.features = features
    ...
</code>
                        </pre>
                    </section>
                    <section>
                        <h2>Main Class</h2>
                        <pre>
<code data-trim data-noescape>
class Computer():
    def __init__(self, processor, motherboard, graphics):
        self.processor = processor
        self.motherboard = motherboard
        self.graphics = graphics
    ...

i9 = Processor("I9-11900KF", 5.3, 8)
rog_strix = Motherboard("ROG Strix Z590-E Gaming WiFi", ["HDMI", [8, "USB-A"], [2, "USB-C"]])
gf_3080 = GraphicsCard("MSI Gaming GeForce RTX 3080 OC Ventus", 1740, ["RTX", "DLSS"])
my_computer = Computer(i9, rog_strix, gf_3080)
</code>
                        </pre>
                    </section>
                    <section>
                        <h2>Composition Lab</h2> 
					    <a href="lab5c.html">Lab 5C</a>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
						<h2>Modules</h2>
						<ul>
                            <li>Modules are reusable code that can be imported into other scripts or programs</li>
                            <li>Modules are single files in either .py, .pyc or .pyo format</li>
                            <li>When a module is imported, code that is not wrapped in a function is executed and the functions themselves are added to the namespace, allowing them to be called upon</li>
                        </ul>
					</section>
                    <section>
						<h4>Module Structure</h4>
						<pre>
<code data-trim data-noescape>
#/usr/lib/python/site-packages/triangle.py

divisor_count_to_find = 500

def triangle_number(n):
    return n*(n+1)/2

def divisors(tn):
    counter = 0
    n_sqrt = int(pow(tn, 0.5))
    for i in range(1, n_sqrt + 1):
        if tn%i == 0:
            counter += 2
    if n_sqrt * n_sqrt == tn:
        counter -= 1
    return counter

def start():
    start_number = 1
    div_numbers = 0
    while (div_numbers < divisor_count_to_find):
        tn = triangle_number(start_number)
        div_numbers = divisors(tn)
        start_number += 1
    print(div_numbers)
    print(tn)

if __name__ == '__main__':
    start()
</code>
                        </pre>
					</section>
                    <section>
						<h4>Using Modules</h4>
						<ul>
							<li>First, we import the module. We will learn more coming up.</li>
							<li>After the module is imported we can begin utilizing the module's objects.</li>
							<li>When a module is imported normally, the module will be on it's own namespace.
								<ul>
									<li>Thus we need to use dot notation to access the modules objects</li>
								</ul>
							</li>
						</ul>
					</section>
                    <section>
						<h4>Importing Modules</h4>
						<ul>
                            <li>The most common way is to import the module is using the import keyword alone</li>
                            <li>These modules are imported from the same dir as your program</li>
                            <li>This method prevents name collisions by putting the modules objects into it's own namespace</li>
                        </ul>
						<pre>
<code data-trim data-noescape>
# Most common, cleanest way to do it. Prevents name collisions. 
import triangle

triangle.method() # Call method
</code>
                        </pre>
					</section>
                    <section>
						<p>There are other methods as well. We can give our modules aliases</p>
						<pre>
<code data-trim data-noescape>
# Same as above except we gave triangle an alias
import triangle as tri

tri.method()
</code>
                        </pre>
						<p>We can also import specific modules without throwing them into a namespace.</p>
						<pre>
<code data-trim data-noescape>
from triangle import divisor_count_to_find, triangle_number

print(divisor_count_to_find) # output 500
triangle_number(5)
</code>
                        </pre>
					</section>
                    <section>
						<p style="font-size:30px">We can take the previous example a step further and implement aliases. This will allow us to change the names up to prevent name collisons.</p>
						<pre>
<code data-trim data-noescape>
from triangle import divisor_count_to_find as dcf, triangle_number as tn

print(dcf) # output 500
tn(5)
</code>
                        </pre>
						<p style="font-size:30px">Lastly, we can also import an entire module without a namespace. The * tells Python to import all modules without a namespace. This is a dangerous method and should only be used if you are sure there will not be collisions.</p>
						<pre>
<code data-trim data-noescape>
from triangle import *
</code>
                        </pre>
					</section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
						<h2>Packages</h2>
						<ul>
                            <li>Packages are a way to structure Python's module namespace</li>
                            <li>A package is just a collection of modules</li>
                            <li>A module named __init__.py is required to treat the directory as a package</li>
                        </ul>
					</section>
                    <section>
						<h2>Package Structure</h2>
						<pre>
<code data-trim data-noescape>
/                   # Top directory
operations/         # Package
    __init__.py     # special file
    pemdas.py       # PEMDAS module 
    shapes.py       # operations related to shapes module 
    logarithm.py    # logarithm module
menu/               # additional package 
    __init__.py 
    uilook.py       # UI used for the calculator
</code>
                        </pre>
					</section>
                    <section>
						<h2>How to Import From a Package</h2>
						<p>So let's take the package below and walk through an import.</p>
						<pre>
<code data-trim data-noescape>
/                   # Top directory
operations/         # Package
    __init__.py     # special file
    pemdas.py       # PEMDAS module 
    shapes.py       # operations related to shapes module 
    logarithm.py    # logarithm module
menu/               # additional package 
    __init__.py 
    uilook.py       # Import and run this file (module)
</code>
                        </pre>
					</section>
                    <section>
						<p>There are two ways we can go about this:</p>
						<pre>
<code data-trim data-noescape>
import menu.uilook

menu.uilook.do_something()                                                                            
</code>
                        </pre>
						<p>OR</p>
						<pre>
<code data-trim data-noescape>
from menu import uilook as ui

ui.do_something()
</code>
                        </pre>
					</section>
                    <section>
						<h4>Useful Commands</h4>
						<pre>
<code data-trim data-noescape>
# dir() Returns list of names in current local scope or with argument, 
# attempts to return a list of valid attributes for object
>>> print(dir())
['__builtins__', '__doc__', '__name__', '__package__']
>>> import(struct)
>>> print(dir())
['__builtins__', '__doc__', '__name__', '__package__', 'struct']
>>> print(dir(struct))
['Struct', '__builtins__', '__doc__', '__file__', '__name__', '__package__', '_clearcache', 'calcsize', 'error', 'pack', 'pack_into', 'unpack', 'unpack_from']

# help() Invokes built-in help system
print(help(struct))
print(help()													)
</code>
                        </pre>
					</section>
                    <section>
                        <h2>Packages Labs</h2> 
                        <a href="lab5d.html">Lab 5D</a>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
						<h2>Exceptions</h2>
						<p>Python exceptions allow you to attempt code that may result in an error and execute additional functionality on said error.</p>
						<ul>
							<li style="font-size: 30px;"><b>Try</b>
								<ul>
									<li style="font-size: 30px;">Will contain the block of code to be tested</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>Except</b>
								<ul>
									<li style="font-size: 30px;">Code to be executed if an exception/error was caught</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>Finally</b>
								<ul>
									<li style="font-size: 30px;">If a finally clause is present, the finally clause will execute as the last task before the try statement completes. </li>
                                    <li>The finally clause runs whether or not the try statement produces an exception.</li>
								</ul>
							</li>
							<li style="font-size: 30px;"><b>Else</b>
								<ul>
									<li style="font-size: 30px;">If no exceptions were caught, the else block will execute after the try code is completed.</li>
								</ul>
							</li>
						</ul>
					</section>
                    <section>
						<h2>Exception Example</h2>
						<pre>
<code data-trim data-noescape>
try:
    #statements
except: 
    #statements
except ErrorType as name_of_error:
    #statements
finally:
    #statements
else:
    #statements
</code>
                        </pre>
					</section>
                    <section>
						<h2>Exception Example 2</h2>
						<pre>
<code data-trim data-noescape>
"""
Checks a certain range of numbers to see if they can divide into a user specified num
"""
# Program main, runs at start of program
def launch():
    num = input('What number would you like to check?')
    amount = input('How many numbers do you want to check?')

    if isInt(num) == False or isInt(amount) == False:
        print("You must enter an integer")
        launch() 
    elif int(amount) < 0 or int(num) < 0:
        print("You must enter a number greater than 0")
        launch() 
    else:
        divisible_by(int(num), int(amount))

# Checks num divisible numbers up to amount or itself
def divisible_by(num, amount):
    i = 1.0
    while (num / i >= 1 and amount > 0):
        if num % i == 0:
            print('{} is divisible by {}'.format(int(num), int(i)))
            amount -= 1
        i += 1

# EXCEPTION HANDLING
def isInt(x):
    try:
        int(x) ###
        return True
    except ValueError:
        return False

launch()
</code>
                        </pre>
					</section>
                    <section>
						<h2>Exception Example 3</h2>
						<pre>
<code data-trim data-noescape>
class CustomError(Exception):
    def _init_(self, msg):
        self.msg = msg
        
    def _str_(self):
        return "your error is {}".format(self.msg)
        
    def doStuff(danger):
        if danger == True:
            raise CustomError("Whoa don't do that!")
            print("Success") #What happens here?

try:
    doStuff(True)
    
except CustomError as stuff:
    print(stuff)
</code>
                        </pre>
					</section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h2>Design Principles of OOP</h2>
                        <ul>
                            <li><strong>SOLID</strong> Design Principles</li>
                            <li>S - Single Responsibility Principle</li>
                            <ul>
                                <li>"A class should have one, and only one, reason to change."</li>
                            </ul>
                            <li>O - Open/Closed Principle</li>
                            <ul>
                                <li>"Software entities (classes, modules, functions, etc.) should be open for extension, but closed for modification."</li>
                            </ul>
                        </ul>
                    </section>
                    <section>
                        <ul>
                            <li>L - Liskov Substitution Principle</li>
                            <ul>
                                <li>A subclass should be able to used in place of the superclass.</li>
                            </ul>
                            <li>I - Interface Segregation Principle</li>
                            <ul>
                                <li>"Clients should not be forced to depend upon interfaces that they do not use."</li>
                            </ul>
                            <li>D - Dependency Inversion Principle</li>
                            <ul>
                                <li>"High-level modules should not depend on low-level modules. Both should depend on abstractions. AND Abstractions should not depend on details. Details should depend on abstractions."</li>
                            </ul>
                        </ul>
                    </section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
						<h2>OOP Terminology Review</h2>
                        <h4>Attribute</h4>
						<ul>
							<li style="font-size:30px;">
								Values associated with an individual object. Attributes are accessed using the 'dot syntax':
							</li>
						</ul>
						<pre>
<code data-trim data-noescape>
a.x means fetch the x attribute from the 'a' object.
</code>
                        </pre>
					</section>
                    <section>
						<h4>Argument</h4>
						<p>A value passed to a function (or method) when calling the function. There are two types of arguments:</p>
						<ul>
							<li>Keyword Argument</li>
							<li>Positional Argument</li>
						</ul>
					</section>
                    <section>
						<h4>Keyword Argument</h4>
						<ul>
							<li>An argument preceded by an identifier (e.g. name=) in a function call or passed as a value in a dictionary preceded by **.</li>
						</ul>
						<pre>
<code data-trim data-noescape>
complex(real=3, imag=5)
complex(**{'real': 3, 'imag': 5})
</code>
                        </pre>
					</section>
					<section>
						<h4>Positional Argument</h4>
						<ul>									
							<li style="font-size:30px;">An argument that is not a keyword argument. Positional arguments can appear at the beginning of an argument list and/or be passed as elements of an iterable preceded by *. For example, 3 and 5 are both positional arguments in the following calls:</li>
						</ul>
						<pre>
<code data-trim data-noescape>
complex(3, 5)
complex(*(3, 5))
</code>
                        </pre>
					</section>
                    <section>
						<p><b>Class</b></p>
						<ul style="font-size:30px">
							<li>
								A template for creating user-defined objects. Class definitions normally contain method definitions that operate on instances of the class.
							</li>
						</ul>
						<p><b>Class Variable</b></p>
						<ul style="font-size:30px">
							<li>
								Variables defined within the class definition that belong to the class. These variables are shared to all instances of the class.
							</li>
						</ul>
						<pre>
<code data-trim data-noescape>
class TestClass:
    i = 10

print(TestClass.i)
</code>
                        </pre>
					</section>
                    <section>
						<p><b>Constructors</b></p>
						<ul>
							<li>
								Functions that are automatically called when you create a new instance of a class.
							</li>
						</ul>
						<p><b>Destructor</b></p>
						<ul>
							<li>
								Called when an object gets destroyed. It's the polar opposite of the constructor, which gets called on creation.
							</li>
						</ul>
					</section>
                    <section>
						<p><b>Inheritance</b></p>
						<ul style="font-size:20px">
							<li>
								A term used in OOP meaning that classes can inherit from other classes. In other words, it's the transfer of characteristics from one class to another class/classes that are derived from it.
							</li>
						</ul>
                        <p><b>Instance Variable</b></p>
						<ul style="font-size:20px">
							<li>
								Similar to Class Variables... except they are only accessible to that one instance. These generally start with the 'self' keyword and are contained within methods.
							</li>
						</ul>
						<pre>
<code data-trim data-noescape>
class NameClass:
    def __init__(self, name):
        self.name = name

dis_class = NameClass('your_name')
print(dis_class.name)
#OUTPUT:
'your_name'
</code>
                        </pre>
					</section>
                    <section>
						<p><b>Object</b></p>
						<ul>
							<li>
								Any data with state (attributes or values) and defined behavior (methods or functions). An object can be assigned to a variable or passed into a function as a argument. It's a unique data structure that's defined by it's type or class, etc.  Remember that <b>everything</b> in Python is an object.
							</li>
							<li><b>Instance: </b>An individual object of a certain class.</li>
							<li><b>Instantiation: </b>Instantiation is the act of creating an object instance from a class.</li>
						</ul>
					</section>
					<section>
						<p><b>Method</b></p>
						<ul style="font-size:30px">
							<li>
								Methods are functions that are called using the attribute notation. There are two flavors: built-in methods (such as append() on lists) and class instance methods. A method is similar to a function but is associated with an object.
							</li>
						</ul>
                        <p><b>Self</b></p>
						<ul style="font-size:30px">
							<li>
								Represents the instance of the class. By using the "self" keyword we can access the attributes and methods of the class in python.
							</li>
						</ul>
                    </section>
                    <section>
                        <p><b>Method Overloading</b></p>
						<ul>
							<li>
								The ability to create multiple functions with the same name. This allows us to pass different parameters. In Python, this is generally not needed. Instead, we can set default and optional parameters.
							</li>
						</ul>
                        <p><b>Method Overriding</b></p>
						<ul>
							<li>
								The ability for a child class to change a method that is inherited from a parent class.  This form of polymorphism is the one that is readily used within Python.
							</li>
						</ul>
                    </section>
                    <section>
						<p><b>Polymorphism</b></p>
						<ul>
							<li>The ability to leverage the same interface for different underlying forms such as data typesclasses or functions.</li> 
							<li>Polymorphism is a way of making a function accept objects of different classes if they behave similarly.</li>
						</ul>
					</section>
                </section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
				    <h2>Questions?</h2>
				</section>
                <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                    <section>
                        <h2>Summary</h2>
                        <ul>
                            <li>Tenets Of OOP</li>
                            <li>Structure of a Class</li>
                            <li>Creating an Instance</li>
                            <li>Using Getter and Setters</li>
                            <li>Parent and Child Classes</li>
                            <li>Method Overloading/Overriding</li>
                        </ul>
                    </section>
                    <section>
                        <h2>Summary (Cont.)</h2>
                        <ul>
                            <li>Composition</li>
                            <li>Modules</li>
                            <li>Packages</li>
                            <li>Exceptions</li>
                            <li>Design Principles</li>
                            <li>Terminology Review</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>
        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	

		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>
